searchNodes=[{"doc":"A generic behaviour to implement Pub/Sub Clients for BroadwayCloudPubSub.Producer . This module defines callbacks to normalize options and receive messages from a Cloud Pub/Sub topic. Modules that implement this behaviour should be passed as the :client option from BroadwayCloudPubSub.Producer .","ref":"BroadwayCloudPubSub.Client.html","title":"BroadwayCloudPubSub.Client","type":"behaviour"},{"doc":"Dispatches an acknowledge request.","ref":"BroadwayCloudPubSub.Client.html#c:acknowledge/2","title":"BroadwayCloudPubSub.Client.acknowledge/2","type":"callback"},{"doc":"","ref":"BroadwayCloudPubSub.Client.html#c:init/1","title":"BroadwayCloudPubSub.Client.init/1","type":"callback"},{"doc":"Invoked once by BroadwayCloudPubSub.Producer during Broadway.start_link/2 . The goal of this task is to manipulate the producer options, if necessary at all, and introduce any new child specs that will be started in Broadway's supervision tree.","ref":"BroadwayCloudPubSub.Client.html#c:prepare_to_connect/2","title":"BroadwayCloudPubSub.Client.prepare_to_connect/2","type":"callback"},{"doc":"Dispatches a modifyAckDeadline request.","ref":"BroadwayCloudPubSub.Client.html#c:put_deadline/3","title":"BroadwayCloudPubSub.Client.put_deadline/3","type":"callback"},{"doc":"Dispatches a pull request.","ref":"BroadwayCloudPubSub.Client.html#c:receive_messages/3","title":"BroadwayCloudPubSub.Client.receive_messages/3","type":"callback"},{"doc":"The amount of time (in seconds) before Pub/Sub should reschedule a message.","ref":"BroadwayCloudPubSub.Client.html#t:ack_deadline/0","title":"BroadwayCloudPubSub.Client.ack_deadline/0","type":"type"},{"doc":"The ackId returned by Pub/Sub to be used when acknowledging a message.","ref":"BroadwayCloudPubSub.Client.html#t:ack_id/0","title":"BroadwayCloudPubSub.Client.ack_id/0","type":"type"},{"doc":"A list of ackId strings.","ref":"BroadwayCloudPubSub.Client.html#t:ack_ids/0","title":"BroadwayCloudPubSub.Client.ack_ids/0","type":"type"},{"doc":"A list of Broadway.Message structs.","ref":"BroadwayCloudPubSub.Client.html#t:messages/0","title":"BroadwayCloudPubSub.Client.messages/0","type":"type"},{"doc":"Default Pub/Sub client used by BroadwayCloudPubSub.Producer to communicate with Google Cloud Pub/Sub service. This client implements the BroadwayCloudPubSub.Client behaviour which defines callbacks for receiving and acknowledging messages.","ref":"BroadwayCloudPubSub.GoogleApiClient.html","title":"BroadwayCloudPubSub.GoogleApiClient","type":"module"},{"doc":"A GenStage producer that continuously receives messages from a Google Cloud Pub/Sub topic and acknowledges them after being successfully processed. By default this producer uses BroadwayCloudPubSub.GoogleApiClient to talk to Cloud Pub/Sub, but you can provide your client by implementing the BroadwayCloudPubSub.Client behaviour. Options using BroadwayCloudPubSub.GoogleApiClient :subscription - Required. The name of the subscription. Example: &quot;projects/my-project/subscriptions/my-subscription&quot; :max_number_of_messages - Optional. The maximum number of messages to be fetched per request. Default is 10 . :return_immediately - Optional. If this field set to true, the system will respond immediately even if it there are no messages available to return in the Pull response. Otherwise, the system may wait (for a bounded amount of time) until at least one message is available, rather than returning no messages. Default is nil . :scope - Optional. A string representing the scope or scopes to use when fetching an access token. Default is &quot;https://www.googleapis.com/auth/pubsub&quot; . Note: The :scope option only applies to the default token generator. :token_generator - Optional. An MFArgs tuple that will be called before each request to fetch an authentication token. It should return {:ok, String.t()} | {:error, any()} . Default generator uses Goth.Token.for_scope/1 with &quot;https://www.googleapis.com/auth/pubsub&quot; . See &quot;Custom token generator&quot; section below for more information. :pool_opts - Optional. A set of additional options to override the default :hackney_pool configuration options. :retry - Optional. Configuration for retries. Any Google PubSub request with error response will be retried a few times before returning the error. :delay - How long to wait (milliseconds) before retrying (positive integer, defaults to 500) :max_retries - Maximum number of retries (non-negative integer, defaults to 10) :should_retry - Function to determine if request should be retried based on the response. Defaults to retrying all errors and responses with status 408, 500, 502, 503, 504, 522, and 524 See Tesla.Middleware.Retry for more information. :middleware - Optional. List of custom Tesla middleware Example: [{Tesla.Middleware.BaseUrl, &quot;https://example.com&quot;}] Custom token generator A custom token generator can be given as a MFArgs tuple. For example, define a MyApp.fetch_token/0 function: defmodule MyApp do @scope &quot;https://www.googleapis.com/auth/pubsub&quot; def fetch_token ( ) do with { :ok , token } &lt;- Goth.Token . for_scope ( @scope ) { :ok , token . token } end end end and configure the producer to use it: token_generator : { MyApp , :fetch_token , [ ] } Acknowledger options These options apply to BroadwayCloudPubSub.GoogleApiClient acknowledgement API: :on_success - Optional. Configures the behaviour for successful messages. See the &quot;Acknowledgements&quot; section below for all the possible values. This option can also be changed for each message through Broadway.Message.configure_ack/2 . Default is :ack . :on_failure - Optional. Configures the behaviour for failed messages. See the &quot;Acknowledgements&quot; section below for all the possible values. This option can also be changed for each message through Broadway.Message.configure_ack/2 . Default is :noop . Additional options These options apply to all producers, regardless of client implementation: :client - Optional. A module that implements the BroadwayCloudPubSub.Client behaviour. This module is responsible for fetching and acknowledging the messages. Pay attention that all options passed to the producer will be forwarded to the client. It's up to the client to normalize the options it needs. Default is BroadwayCloudPubSub.GoogleApiClient . :pool_size - Optional. The size of the connection pool. Default is twice the producer concurrency. :receive_interval - Optional. The duration (in milliseconds) for which the producer waits before making a request for more messages. Default is 5000. Acknowledgements You can use the :on_success and :on_failure options to control how messages are acknowledged with the Pub/Sub system. By default successful messages are acknowledged and failed messages are ignored. You can set :on_success and :on_failure when starting this producer, or change them for each message through Broadway.Message.configure_ack/2 . The following values are supported by both :on_success and :on_failure : :ack - Acknowledge the message. Pub/Sub can remove the message from the subscription. :noop - Do nothing. No requests will be made to Pub/Sub, and the message will be rescheduled according to the subscription-level ackDeadlineSeconds . :nack - Make a request to Pub/Sub to set ackDeadlineSeconds to 0 , which may cause the message to be immediately redelivered to another connected consumer. Note that this does not modify the subscription-level ackDeadlineSeconds used for subsequent messages. {:nack, integer} - Modifies the ackDeadlineSeconds for a particular message. Note that this does not modify the subscription-level ackDeadlineSeconds used for subsequent messages. Batching Even if you are not interested in working with Broadway batches via the handle_batch/3 callback, we recommend all Broadway pipelines with Pub/Sub producers to define a default batcher with batch_size set to 10, so messages can be acknowledged in batches, which improves the performance and reduces the cost of integrating with Google Cloud Pub/Sub. Example Broadway . start_link ( MyBroadway , name : MyBroadway , producer : [ module : { BroadwayCloudPubSub.Producer , subscription : &quot;projects/my-project/subscriptions/my_subscription&quot; } ] , processors : [ default : [ ] ] , batchers : [ default : [ batch_size : 10 , batch_timeout : 2_000 ] ] ) The above configuration will set up a producer that continuously receives messages from &quot;projects/my-project/subscriptions/my_subscription&quot; and sends them downstream.","ref":"BroadwayCloudPubSub.Producer.html","title":"BroadwayCloudPubSub.Producer","type":"module"},{"doc":"BroadwayCloudPubSub A Google Cloud Pub/Sub connector for Broadway . Documentation can be found at https://hexdocs.pm/broadway_cloud_pub_sub . This project provides: BroadwayCloudPubSub.Producer - A GenStage producer that continuously receives messages from a Pub/Sub subscription acknowledges them after being successfully processed. BroadwayCloudPubSub.Client - A generic behaviour to implement Pub/Sub clients. BroadwayCloudPubSub.GoogleApiClient - Default REST client used by BroadwayCloudPubSub.Producer .","ref":"readme.html","title":"BroadwayCloudPubSub","type":"extras"},{"doc":"Add :broadway_cloud_pub_sub to the list of dependencies in mix.exs : def deps do [ { :broadway_cloud_pub_sub , &quot;~&gt; 0.7.0&quot; } , { :goth , &quot;~&gt; 1.0&quot; } ] end Note the goth package, which handles Google Authentication, is required for the default token generator.","ref":"readme.html#installation","title":"BroadwayCloudPubSub - Installation","type":"extras"},{"doc":"Configure Broadway with one or more producers using BroadwayCloudPubSub.Producer : Broadway . start_link ( MyBroadway , name : MyBroadway , producer : [ module : { BroadwayCloudPubSub.Producer , subscription : &quot;projects/my-project/subscriptions/my-subscription&quot; } ] )","ref":"readme.html#usage","title":"BroadwayCloudPubSub - Usage","type":"extras"},{"doc":"Copyright 2019 Michael Crumm Copyright 2020 Dashbit Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http :/ / www . apache . org / licenses / LICENSE - 2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#license","title":"BroadwayCloudPubSub - License","type":"extras"},{"doc":"Changelog All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - Unreleased","type":"extras"},{"doc":"Changed Require Broadway 1.0","ref":"changelog.html#0-7-0-2021-08-30","title":"Changelog - 0.7.0 - 2021-08-30","type":"extras"},{"doc":"Changed Remove sensitive details from error log messages Added A new :middleware option to pass a list of custom Tesla middleware Failures to ack are now automatically retried. Retries can be customised via the new :retry option","ref":"changelog.html#0-6-3-2021-07-19","title":"Changelog - [0.6.3] - 2021-07-19","type":"extras"},{"doc":"Changed Fixed a bug causing malformed acknowledgement requests (#54)","ref":"changelog.html#0-6-2-2021-02-24","title":"Changelog - 0.6.2 - 2021-02-24","type":"extras"},{"doc":"Changed Decreased maximum number of ackIds per request (#49)","ref":"changelog.html#0-6-1-2021-02-23","title":"Changelog - 0.6.1 - 2021-02-23","type":"extras"},{"doc":"Added Support for passing a tuple for the scope option Changed Require Broadway v0.6.0","ref":"changelog.html#0-6-0-2020-02-18","title":"Changelog - 0.6.0 - 2020-02-18","type":"extras"},{"doc":"Added Client options for connection pools (#37) Support for configuring acknowledgement behavior (#36) Changed Move acknowledger behaviour from GoogleApiClient into ClientAcknowledger (#39)","ref":"changelog.html#0-5-0-2019-11-06","title":"Changelog - 0.5.0 - 2019-11-06","type":"extras"},{"doc":"Changed Move to Plataformatec GitHub organization and become an official Broadway connector Rename behaviour RestClient to Client (#23) Use hackney as the default adapter (#20) Require Broadway 0.4.x and (optionally) Goth 1.x (#26) Replace :token_module option with :token_generator (#29) Hide handle_receive_messages function that was accidentally made public","ref":"changelog.html#0-4-0-2019-08-19","title":"Changelog - 0.4.0 - 2019-08-19","type":"extras"},{"doc":"Changed BREAKING: The PubsubMessage struct now gets unpacked into the %Broadway.Message{} received in your pipeline. If you were using message.data.data before, you can now use message.data . Additional properties from the PubsubMessage can be found in the message metadata, for instance: message.metadata.attributes or message.metadata.messageId . Requires :broadway ~&gt; 0.3.0","ref":"changelog.html#0-3-0-2019-05-08","title":"Changelog - 0.3.0 - 2019-05-08","type":"extras"},{"doc":"Changed Fixed BroadwayCloudPubSub.GoogleApiClient attempting to send an empty acknowledge request.","ref":"changelog.html#0-1-3-2019-05-06","title":"Changelog - 0.1.3 - 2019-05-06","type":"extras"},{"doc":"Changed MIX_ENV for publishing releases to Hex.","ref":"changelog.html#0-1-2-2019-04-11","title":"Changelog - 0.1.2 - 2019-04-11","type":"extras"},{"doc":"Added This CHANGELOG file to hopefully serve as an evolving example of a standardized open source project CHANGELOG . Changed Fixed CircleCI build for publishing docs to Hex.","ref":"changelog.html#0-1-1-2019-04-11","title":"Changelog - 0.1.1 - 2019-04-11","type":"extras"},{"doc":"Added BroadwayCloudPubSub.Producer - A GenStage producer that continuously receives messages from a Pub/Sub subscription acknowledges them after being successfully processed. BroadwayCloudPubSub.RestClient - A generic behaviour to implement Pub/Sub clients using the REST API . BroadwayCloudPubSub.GoogleApiClient - Default REST client used by BroadwayCloudPubSub.Producer . BroadwayCloudPubSub.Token - A generic behaviour to implement token authentication for Pub/Sub clients. BroadwayCloudPubSub.GothToken - Default token provider used by BroadwayCloudPubSub.Producer .","ref":"changelog.html#0-1-0-2019-04-10","title":"Changelog - 0.1.0 - 2019-04-10","type":"extras"}]